%bcond_with     gtk
%bcond_with     xaw3d
%bcond_without  debug
%bcond_without  mule
%bcond_with     stackprot
%bcond_without  gcc32

%define pkgdir  %{_datadir}/xemacs
%define exectop %{_libdir}/xemacs-%{version}

Name:           xemacs
Version:        21.4.19
Release:        4
Summary:        Different version of Emacs

Group:          Applications/Editors
License:        GPL
URL:            http://www.xemacs.org/
Source0:        ftp://ftp.xemacs.org/xemacs-21.4/xemacs-%{version}.tar.bz2
Source1:        %{name}.png
Source6:        xemacs.desktop
Source9:        xemacs-sitestart.el
# Used for cleaning finder-inf.el when it needs compilation
Source22:       delprevline.py
Source23:       dotxemacs-init.el
Source24:       default.el
Patch1:         xemacs-21.4.19-x-paths.patch
Patch10:        xemacs-21.4.19-find-paths-pkgdir.patch
Patch11:        movemail-mktemp.patch
Patch16:        xemacs-21.4.12-mk-nochk-features.patch
Patch18:        xemacs-21.4.13-dump-paths-lispdir.patch
Patch19:        xemacs-21.4.18-utf8-fonts.patch
Patch21:        xemacs-debian-docdir-dump.patch
Patch23:        xemacs-no-expdyn-ia64-106744.patch
Patch24:        xemacs-21.4.15-wnnfix-128362.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires:  autoconf213
BuildRequires:  python
BuildRequires:  sed >= 3.95
BuildRequires:  texinfo
BuildRequires:  ncurses-devel
BuildRequires:  gpm-devel
BuildRequires:  pam-devel
BuildRequires:  zlib-devel
BuildRequires:  libjpeg-devel
BuildRequires:  compface
BuildRequires:  libpng-devel
BuildRequires:  libtiff-devel
BuildRequires:  desktop-file-utils
%if %{with mule}
BuildRequires:  Canna-devel
BuildRequires:  FreeWnn-devel
%endif # mule
%if %{with gtk}
BuildRequires:  gtk+-devel
BuildRequires:  libglade-devel
%else
%if %{with xaw3d}
BuildRequires:  Xaw3d-devel
%else
BuildRequires:  neXtaw-devel
%endif # xaw3d
%endif # gtk
BuildRequires:  xmkmf
%if %{with gcc32}
BuildRequires:  compat-gcc-32
%endif
BuildRequires:  libXau-devel
# TODO: verify these build deps wrt gtk/xaw3d builds
BuildRequires:  xorg-x11-xbitmaps
BuildRequires:  libXaw-devel
BuildRequires:  libXpm-devel
Requires:       xemacs-sumo >= 20050118-2
Requires:       xemacs-common = %{version}-%{release}
Requires:       xorg-x11-fonts-ISO8859-1-75dpi
Requires:       xorg-x11-fonts-ISO8859-1-100dpi

%description
XEmacs is a highly customizable open source text editor and
application development system.  It is protected under the GNU General
Public License and related to other versions of Emacs, in particular
GNU Emacs.  Its emphasis is on modern graphical user interface support
and an open software development model, similar to Linux.

This package contains XEmacs built for X Windows%{?with_mule: with MULE support}.

%package        common
Summary:        Byte-compiled lisp files and other common files for XEmacs
Group:          Applications/Editors
Requires(post): %{_sbindir}/alternatives
Requires(preun): %{_sbindir}/alternatives

%description    common
XEmacs is a highly customizable open source text editor and
application development system.  It is protected under the GNU General
Public License and related to other versions of Emacs, in particular
GNU Emacs.  Its emphasis is on modern graphical user interface support
and an open software development model, similar to Linux.

This package contains byte-compiled lisp and other common files for XEmacs.

%package        nox
Summary:        Different version of Emacs built without X Windows support
Group:          Applications/Editors
# Note: no xemacs-sumo dependency here, we need -nox to build the sumo package.
Requires:       xemacs-common = %{version}-%{release}

%description    nox
XEmacs is a highly customizable open source text editor and
application development system.  It is protected under the GNU General
Public License and related to other versions of Emacs, in particular
GNU Emacs.  Its emphasis is on modern graphical user interface support
and an open software development model, similar to Linux.

This package contains XEmacs built without X Windows support.

%package        el
Summary:        Emacs lisp source files for XEmacs
Group:          Development/Libraries

%description    el
XEmacs is a highly customizable open source text editor and
application development system.  It is protected under the GNU General
Public License and related to other versions of Emacs, in particular
GNU Emacs.  Its emphasis is on modern graphical user interface support
and an open software development model, similar to Linux.

This package contains the lisp source files for XEmacs, mainly of
interest when developing or debugging XEmacs itself.

%package        info
Summary:        XEmacs documentation in GNU texinfo format
Group:          Documentation
Requires(post): /sbin/install-info
Requires(preun): /sbin/install-info

%description    info
XEmacs is a highly customizable open source text editor and
application development system.  It is protected under the GNU General
Public License and related to other versions of Emacs, in particular
GNU Emacs.  Its emphasis is on modern graphical user interface support
and an open software development model, similar to Linux.

This package contains XEmacs documentation in GNU texinfo format.


%prep
%setup -q

f=etc/xemacs-ja.1 ; iconv -f euc-jp -t utf-8 $f > $f.utf8 ; mv $f.utf8 $f

find . -type f -name "*.elc" -o -name "*.info*" | xargs rm -f

## lisp patches ##

%patch1 -p1
# make find-paths.el look in datadir
%patch10 -p1
# fix "libexec" on multilib
sed -i -e 's/"lib"/"%{_lib}"/' lisp/find-paths.el
# remove game we shouldn't ship
sed -i -e /tetris/d lisp/menubar-items.el
# make lisp dir and mule-lisp dir be the source lisp dirs (not in datadir)
%patch18 -p1
sed -i -e "s|\@srcdir\@|$PWD|" lisp/dump-paths.el

## non-lisp patches ##

# movemail
%patch11 -p1 -b .mkstemp
# skip redundant check-features
%patch16 -p1 -b .feature-chk
# fix missing charsets warning with Xaw/UTF-8
%patch19 -p1
# look for dump file docdir/DUMP as well as bindir/xemacs.dmp
%patch21 -p1 -b .docdmp
%ifarch ia64
# don't link with -dynamic-export on ia64
%patch23 -p1 -b .dyn-exp
%endif
# remove cwnn symbols
%patch24 -p1 -b .cwnn

# patch21 touches configure.in, and patch23 touches aclocal.m4
autoconf-2.13


%build
CFLAGS="${CFLAGS:-$RPM_OPT_FLAGS -fno-strict-aliasing}"
%if ! %{with stackprot}
CFLAGS="$(echo $CFLAGS | sed -e 's/-fstack-protector\s*//g')"
CFLAGS="$(echo $CFLAGS | sed -e 's/--param=ssp-buffer-size=[0-9]\+\s*//')"
%endif
%if %{with gcc32}
CFLAGS="$(echo $CFLAGS | sed -e 's/mtune/mcpu/')"
CFLAGS="$(echo $CFLAGS | sed -e 's/-mcpu=generic//')"
CFLAGS="$(echo $CFLAGS | sed -e 's/-fstack-protector\s*//g')"
CFLAGS="$(echo $CFLAGS | sed -e 's/--param=ssp-buffer-size=[0-9]\+\s*//')"
export CC=gcc32
%endif
export CFLAGS

# XEmacs still uses Autoconf 2.13 and doesn't know --sbindir, --sysconfdir,
#   --includedir, --libexecdir, --localstatedir, --sharedstatedir
# note: datadir has to be defined because it defaults to /usr/lib
common_options="
  %{_target_platform}
  --prefix=%{_prefix}
  --datadir=%{_datadir}
  --infodir=%{_infodir}
  --libdir=%{_libdir}
  --mandir=%{_mandir}/man1
  --with-gpm=yes
  --with-pop
  --mail-locking=lockf
  --with-clash-detection
  --with-database=no
  --with-postgresql=no
  --with-ldap=no
  --with-hesiod=no
  --with-msw=no
  --pdump
  --debug=%{?with_debug:yes}%{!?with_debug:no}
  %{?with_mule:--with-mule=yes}
%ifarch alpha ia64 ppc64
  --with-system-malloc
%endif
%ifarch ia64
  --without-modules
%endif
"

# build without X
# note: docdir requires trailing slash
./configure $common_options \
  --docdir=%{exectop}/doc-nox/ \
  --with-sound=no \
  --with-x11=no \
  --with-canna=no \
  --with-wnn=no \
  --with-xim=no
# toplevel smp build fails
make %{?_smp_mflags} -C lib-src
#make src/Emacs.ad.h
make %{?_smp_mflags} -C src
EMACSLOADPATH=$PWD/lisp make # EMACSDEBUGPATHS=yes
mv lib-src/DOC{,-nox}
mv src/xemacs{,-nox-%{version}}
mv src/{xemacs.dmp,DUMP-nox}
mv lib-src/config.values{,-nox}

# build with X
# note: docdir requires trailing slash
./configure $common_options \
  --docdir=%{exectop}/doc/ \
  --with-sound=native \
  --with-xim=xlib \
%if %{with gtk}
  --with-gtk \
  --with-gnome \
%else
  --with-athena=%{?with_xaw3d:3d}%{!?with_xaw3d:next} \
  --with-widgets=athena \
  --with-menubars=lucid \
  --with-scrollbars=lucid \
  --with-dialogs=athena \
%endif
  --with-xfs=no
# toplevel smp build fails
make %{?_smp_mflags} -C lib-src
make src/Emacs.ad.h
make %{?_smp_mflags} -C src
EMACSLOADPATH=$PWD/lisp make # EMACSDEBUGPATHS=yes


%install
rm -rf $RPM_BUILD_ROOT

# adjust mandir
export EMACSLOADPATH=$PWD/lisp

install -dm 755 $RPM_BUILD_ROOT%{exectop}/doc
# note: no DESTDIR support, docdir requires trailing slash
%makeinstall \
  mandir=$RPM_BUILD_ROOT%{_mandir}/man1 \
  docdir=$RPM_BUILD_ROOT%{exectop}/doc/
install -Dpm 644 etc/xemacs-ja.1 $RPM_BUILD_ROOT%{_mandir}/ja/man1/xemacs.1
echo ".so man1/xemacs.1" > $RPM_BUILD_ROOT%{_mandir}/man1/xemacs-nox.1
echo ".so man1/xemacs.1" > $RPM_BUILD_ROOT%{_mandir}/ja/man1/xemacs-nox.1

# install nox files
install -pm 755 src/xemacs-nox-%{version} $RPM_BUILD_ROOT%{_bindir}
ln -s xemacs-nox-%{version} $RPM_BUILD_ROOT%{_bindir}/xemacs-nox
install -dm 755 $RPM_BUILD_ROOT%{exectop}/doc-nox
install -pm 644 src/DUMP-nox $RPM_BUILD_ROOT%{exectop}/doc-nox/DUMP
install -pm 644 lib-src/DOC-nox $RPM_BUILD_ROOT%{exectop}/doc-nox/DOC
install -pm 644 lib-src/config.values-nox \
  $RPM_BUILD_ROOT%{exectop}/doc-nox/config.values

mv $RPM_BUILD_ROOT%{_bindir}/xemacs-%{version}-*.dmp \
  $RPM_BUILD_ROOT%{exectop}/doc/DUMP

# these clash with GNU Emacs
mv $RPM_BUILD_ROOT%{_bindir}/etags{,.xemacs}
rm -f $RPM_BUILD_ROOT%{_bindir}/{ctags,rcs-checkin,b2m}
mv $RPM_BUILD_ROOT%{_mandir}/man1/etags{,.xemacs}.1
rm -f $RPM_BUILD_ROOT%{_mandir}/man1/ctags.1

# these clash with other packages
rm -f $RPM_BUILD_ROOT%{_infodir}/info*
rm -f $RPM_BUILD_ROOT%{_infodir}/standards*
rm -f $RPM_BUILD_ROOT%{_infodir}/termcap*
rm -f $RPM_BUILD_ROOT%{_infodir}/dir

desktop-file-install \
  --vendor=fedora \
  --mode=644 \
  --dir=$RPM_BUILD_ROOT%{_datadir}/applications \
  --add-category=X-Fedora \
  %{SOURCE6}

# lockdir
install -dm 1777 $RPM_BUILD_ROOT%{_localstatedir}/lock/xemacs

# site-start.el
install -dm 755 $RPM_BUILD_ROOT%{pkgdir}/site-packages/lisp/site-start.d
install -pm 644 %{SOURCE9} \
  $RPM_BUILD_ROOT%{pkgdir}/site-packages/lisp/site-start.el

# default.el
install -pm 644 %{SOURCE24} $RPM_BUILD_ROOT%{pkgdir}/site-packages/lisp

# default user init file
install -Dpm 644 %{SOURCE23} $RPM_BUILD_ROOT%{_sysconfdir}/skel/.xemacs/init.el

# icon
install -Dpm 644 %{SOURCE1} \
  $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/48x48/apps/xemacs.png

# make sure nothing is 0400
chmod -R a+rX $RPM_BUILD_ROOT%{_prefix}

# filter out buildroot from finder-inf.el
sed -i -e "s|$RPM_BUILD_ROOT||" \
  $RPM_BUILD_ROOT%{_datadir}/xemacs-%{version}/lisp/finder-inf.el
[ -x %{_bindir}/xemacs ] && \
  python %{SOURCE22} \
  $RPM_BUILD_ROOT%{_datadir}/xemacs-%{version}/lisp/finder-inf.el

# clean up "junk" (TODO: there's much more!)
cd $RPM_BUILD_ROOT%{_datadir}/xemacs-%{version}/etc
rm -r aliases.ksh BETA *.sh CODING-STANDARDS InstallGuide \
    sparcworks tests XKeysymDB *.sco *.1 
cd -

# separate files
rm -f *.files base-files el-files info-files
echo "%%defattr(-,root,root,-)" > base-files
echo "%%defattr(-,root,root,-)" > el-files
echo "%%defattr(-,root,root,-)" > info-files

find $RPM_BUILD_ROOT%{_datadir}/xemacs-%{version} $RPM_BUILD_ROOT%{pkgdir} \
  \( -type f -not -name '*.el' -fprint base-non-el.files \) -o \
  \( -type d -name info -fprint info.files -prune \) -o \
  \( -type d -fprintf dir.files "%%%%dir %%p\n" \) -o \
  \( -name '*.el' \( -exec test -e '{}'c \; -fprint el-bytecomped.files -o \
     -fprint base-el-not-bytecomped.files \) \)
sed -i -e "s|$RPM_BUILD_ROOT||" *.files

# make site-packages lisp files config files
sed -i -e 's|^\(.*/site-packages/lisp/.*\)$|%%config(noreplace) \1|' \
  base-el-not-bytecomped.files

# combine the file lists
cat base-*.files dir.files >> base-files
cat el-*.files dir.files >> el-files
cat info.files >> info-files


%clean
rm -rf $RPM_BUILD_ROOT


%post
gtk-update-icon-cache -qf %{_datadir}/icons/hicolor 2>/dev/null || :
update-desktop-database -q %{_datadir}/applications 2>/dev/null || :

%postun
gtk-update-icon-cache -qf %{_datadir}/icons/hicolor 2>/dev/null || :
update-desktop-database -q %{_datadir}/applications 2>/dev/null || :

%post common
%{_sbindir}/alternatives --install %{_bindir}/etags etags \
  %{_bindir}/etags.xemacs 40 || :

%preun common
if [ $1 -eq 0 ] ; then
  %{_sbindir}/alternatives --remove etags %{_bindir}/etags.xemacs || :
fi

%post info
for file in xemacs cl internals lispref new-users-guide ; do
  /sbin/install-info %{_infodir}/$file.info %{_infodir}/dir || :
done

%preun info
if [ $1 -eq 0 ] ; then
  for file in xemacs cl internals lispref new-users-guide ; do
    /sbin/install-info --delete %{_infodir}/$file.info %{_infodir}/dir || :
  done
fi


%files
%defattr(-,root,root,-)
%{_bindir}/xemacs
%{_bindir}/xemacs-%{version}
# gnuclient, gnuserv need X libs, so not in -common
%{_bindir}/gnuclient
%{exectop}/*linux/gnuserv
%{exectop}/doc/
%{_datadir}/applications/*-%{name}.desktop
%{_datadir}/icons/hicolor/48x48/apps/xemacs.png
%{_mandir}/man1/gnuclient.1*
%{_mandir}/man1/gnuserv.1*

%files nox
%defattr(-,root,root,-)
%{_bindir}/xemacs-nox
%{_bindir}/xemacs-nox-%{version}
%{exectop}/doc-nox/

%files common -f base-files
%defattr(-,root,root,-)
%doc INSTALL README COPYING GETTING.GNU.SOFTWARE PROBLEMS CHANGES-release
%doc etc/NEWS etc/MAILINGLISTS BUGS README.packages etc/TUTORIAL
%doc etc/editclient.sh
%{_bindir}/ellcc
%{_bindir}/etags.xemacs
%{_bindir}/gnuattach
%{_bindir}/gnudoit
%{_bindir}/ootags
%dir %{exectop}/
%dir %{exectop}/*linux/
%{exectop}/*linux/[acdfhimprsvwy]*
%{exectop}/*linux/gzip-el.sh
%config(noreplace) %{_sysconfdir}/skel/.xemacs/
%{_mandir}/man1/etags.xemacs.1*
%{_mandir}/man1/gnuattach.1*
%{_mandir}/man1/gnudoit.1*
%{_mandir}/man1/xemacs*.1*
%lang(ja) %{_mandir}/ja/man1/xemacs*.1*
%dir %{_localstatedir}/lock/xemacs/

%files el -f el-files
%defattr(-,root,root,-)

%files info -f info-files
%defattr(-,root,root,-)
%{_infodir}/*.info*


%changelog
* Fri Mar 31 2006 Ville Skyttä <ville.skytta at iki.fi> - 21.4.19-4
- Build with gcc 3.2.x (#183643).
- Don't ship patch backup files.

* Sat Mar 18 2006 Ville Skyttä <ville.skytta at iki.fi> - 21.4.19-3
- Build without -fstack-protector by default for now (#183643).

* Thu Feb  2 2006 Ville Skyttä <ville.skytta at iki.fi> - 21.4.19-2
- 21.4.19, X paths patch mostly applied upstream.

* Tue Dec 13 2005 Ville Skyttä <ville.skytta at iki.fi>
- Don't set Info-directory-list in site-start.el to fix honoring INFOPATH
  from the environment (Geert Kloosterman).

* Mon Dec  5 2005 Ville Skyttä <ville.skytta at iki.fi>
- Fix typo in -info summary.
- Point to main man page for xemacs-nox.

* Sun Dec  4 2005 Ville Skyttä <ville.skytta at iki.fi> - 21.4.18-2
- 21.4.18, innerbuf and cursor patches applied upstream.

* Wed Nov 30 2005 Ville Skyttä <ville.skytta at iki.fi> - 21.4.17-7
- Require ISO-8859-1 fonts (Alexandre Oliva, #174617).
- Make popup dialog font the intended one even without ISO-8859 fonts.
- BuildRequire xmkmf to get X defines during build.
- Move editclient.sh to docs.

* Mon Nov 28 2005 Ville Skyttä <ville.skytta at iki.fi> - 21.4.17-6
- More modular X.Org fixes (Xauth for gnuclient, menubar font tweak).
- Re-enable Canna and FreeWnn (bug introduced in 21.4.17-5).
- Don't ship patch backup files.

* Fri Nov 25 2005 Ville Skyttä <ville.skytta at iki.fi> - 21.4.17-5
- Adapt to modular X.Org.
- Move icon to icons/hicolor and to the main package.
- Move man pages to subpackages where the things they document are,
  install a few more of them.
- Mark config files as noreplace.
- Drop no longer needed obsoletions.
- Start cleaning up unneeded files.
- Don't use %%exclude.
- Use %%bcond_with*.

* Thu Jun 30 2005 Ville Skyttä <ville.skytta at iki.fi> - 21.4.17-4
- Improve package summaries and descriptions, reformat/clean up specfile.
- Bring back Wnn support.
- Fine tune dependencies and options of "--without mule" builds.
- Use desktop-file-install for installing the desktop entry, fix up X-*
  categories, update desktop database at post (un)install time.
- Really mark default init files as %%config.
- Use sed instead of perl for in-place edits throughout the build.
- Drop redundant build dependencies.
- Make sure scriptlet errors won't break upgrades.
- Add context marked dependencies for scriptlets.
- Build with -fno-strict-aliasing per upstream recommendations.
- Use neXtaw by default, rebuild with "--with xaw3d" to get Xaw3d.
- Don't own %%{_bindir} in -common.

* Thu May  5 2005 Ville Skyttä <ville.skytta at iki.fi> - 21.4.17-3
- Avoid stack corruption in open-network-stream when built with gcc4
  (Enrico Scholz, #154112).

* Tue Mar  1 2005 Ville Skyttä <scop@xemacs.org> - 21.4.17-2
- Drop xemacs-sumo build dependency and -nox install time dependency on it
  to solve chicken-egg bootstrap problem.
- Include X-Face support.
- Include Glade support when built with GTK.
- Include prettier icon, based on upstream xemacs.xpm.
- Drop FreeWnn-devel build dependency.
- Drop main package dependency from -info.
- Require updated -sumo.
- Avoid shipping patch backups.
- Improve package summaries and descriptions.
- Trim pre-XEmacs-21.4 %%changelog entries.
- Some specfile maintainablity improvements and cleanups.

* Fri Feb 25 2005 Jens Petersen <petersen@redhat.com>
- use PreReq not Requires(post,preun) for install and uninstall script
  requirements (Axel Thimm, 147791)
- use sed instead of perl to fixup filelists

* Mon Feb  7 2005 Jens Petersen <petersen@redhat.com> - 21.4.17-1
- update to 21.4.17
  - fixes movemail format string vulnerability (CAN-2005-0100, 146705)
  - xemacs-21.4.16-xutil-keysym-144601.patch no longer needed

* Tue Jan 25 2005 Jens Petersen <petersen@redhat.com> - 21.4.16-2
- workaround xorg-x11 issue with iso-level3-shift (Ville Skyttä, 144601)
  - add xemacs-21.4.16-xutil-keysym-144601.patch

* Mon Dec 13 2004 Jens Petersen <petersen@redhat.com> - 21.4.16-1
- update to new stable release
  - no longer need configure-ppc-ldscript.patch and
    xemacs-21.4.15-pui-120437.patch
- default to unified diff in .xemacs/init.el

* Thu Nov 18 2004 Jens Petersen <petersen@redhat.com> - 21.4.15-10
- show xemacs again in the desktop menu (132567)

* Mon Oct 18 2004 Jens Petersen <petersen@redhat.com> - 21.4.15-9
- fix etag alternatives removal when uninstalling (Karsten Hopp, 136137)

* Wed Oct  6 2004 Jens Petersen <petersen@redhat.com>
- xemacs-el no longer requires xemacs for -nox users
  (Lars Hupfeldt Nielsen, 134479)

* Thu Sep 30 2004 Jens Petersen <petersen@redhat.com> - 21.4.15-8
- cleanup and update .desktop file
- make xemacs not appear in the desktop menu (Seth Nickell,132567)
- move the desktop file from -common to main package
- etags is now handled by alternatives (92256)
- no longer require ctags
- turn back on wnn support and add xemacs-21.4.15-wnnfix-128362.patch
  (Yukihiro Nakai, 128362)

* Tue Jun 15 2004 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Mon Jun  7 2004 Jens Petersen <petersen@redhat.com> - 21.4.15-6
- don't link with -export-dynamic on ia64 to stop dumped function pointers from
  breaking (Roland McGrath & Jakub Jelinek, #106744)
- disable dynamic module support on ia64
- change the xemacs-info uninstall script from %%postun to %%preun and move
  the post/preun install-info requires to xemacs-info
- simplify coding-system setup somewhat in site-start.el
- fix up the desktop file (Ville Skyttä, 123135)
- xemacs-nox now requires xemacs-sumo
- build without xfs since it seems to cause some problem with fonts missing

* Wed May  5 2004 Jens Petersen <petersen@redhat.com>
- move install-info requirement to xemacs-info
- drop unnecessary Canna-libs requirement

* Fri Apr  9 2004 Jens Petersen <petersen@redhat.com> - 21.4.15-5
- add xemacs-21.4.15-pui-120437.patch to fix pui problems in 21.4.15
  (Ville Skyttä)
- buildrequire gpm-devel and build xemacs-nox with gpm (Ville Skyttä,120437)
- separate patches into lisp and non-lisp patches
- move gnuclient and gnuserv from xemacs-common to xemacs since they
  require X libs (Ville Skyttä,110649)

* Wed Apr  7 2004 Jens Petersen <petersen@redhat.com> - 21.4.15-4
- add xemacs-nox subpackage (Jamie Zawinski, #110649) and xemacs-common
  - add xemacs-debian-docdir-dump.patch and put dump files in docdir
  - xemacs and xemacs-nox require xemacs-common
  - define exectop and use it
  - one configure and build for xemacs-nox and one for xemacs
- update package descriptions
- don't create backup of patched Emacs.ad since it gets installed, and
  drop Canna-devel version requirement (Ville Skyttä, #115270)
- default ispell dictionary to english for CJK locale, since aspell doesn't
  support widechars (#103145)
- rebuild against latest Canna built with xorg-x11 xmkmf (Kaj Niemi, #119562)
- simplify coding-system setup
- enable gpm for xemacs package

* Tue Mar 16 2004 Mike A. Harris <mharris@redhat.com> 21.4.15-3
- Removed bogus Requires: XFree86-libs, and other similar library runtime
  dependancies, because rpm find-requires automatically puts dependancy info
  in the binary rpms which are on the .so files rather than a specific
  package.  The XFree86-libs removal is necessary in order to replace XFree86
  with xorg-x11 in an X11 implementation agnostic fashion.  (#118483)
- Changed "Requires(post,preun): info" dependancy to
  "Requires(post,postun): /sbin/install-info"

* Tue Mar 02 2004 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Fri Feb 13 2004 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Thu Feb  5 2004 Jens Petersen <petersen@redhat.com> - 21.4.15-1
- update to 21.4.15
- improve language and coding-system startup in site-start.el like
  lang-coding-systems-init.el in emacs package
- build without wnn support
- drop xemacs-21.4.13-regexp-stack-overflow-107402.patch

* Sat Dec 27 2003 Jens Petersen <petersen@redhat.com> - 21.4.14-6
- set EMACSLOADPATH during final make and install so that it is buildable
  even when xemacs isn't installed
- disable ldap, postgresql and dbm support for now (#110649) [jwz]

* Sat Dec 13 2003 Jeff Johnson <jbj@jbj.org>
- rebuild against db-4.2.52.

* Fri Nov  7 2003 Jens Petersen <petersen@redhat.com> - 21.4.14-5
- add a "--without mule" rpmbuild option for the 8bit dead-hards (#102718)
  which disables mule and Input Method support
- only load un-define in site-start.el when there is mule support

* Thu Nov  6 2003 Jens Petersen <petersen@redhat.com> - 21.4.14-4
- increase regexp re_max_failures to 40000 in
  xemacs-21.4.13-regexp-stack-overflow-107402.patch (#107402) [Rik Faith]

* Mon Oct 27 2003 Jens Petersen <petersen@redhat.com> - 21.4.14-3
- no longer obsolete xemacs-sumo-el for xemacs-el [thanks to Axel Thimm]
- fix "Stack overflow in regexp matcher" (#107402) [reported by Rik Faith,
  patch by Stephen J. Turnbull]

* Fri Oct 17 2003 Jens Petersen <petersen@redhat.com> - 21.4.14-2
- require Canna-libs not Canna
- move CJK X resource files to xemacs-sumo
- no longer need to define ispell program to be aspell

* Thu Sep 25 2003 Jeff Johnson <jbj@jbj.org> - 21.4.14-1.1
- rebuild against db-4.2.42.

* Mon Sep  8 2003 Jens Petersen <petersen@redhat.com> - 21.4.14-1
- update to 21.4.14
- default require-final-newline to t in site-start.el (#102022)

* Tue Sep  2 2003 Jens Petersen <petersen@redhat.com> - 21.4.13-5
- default require-final-newline to ask in site-start.el
  and remove redundant setting of next-line-add-newlines to nil in default.el
  (#102022) [reported by Ville Skyttä]

* Mon Jul 14 2003 Jens Petersen <petersen@redhat.com> - 21.4.13-4
- build with --debug=yes by default (suggested by Ville Skyttä)

* Sun Jul 13 2003 Ville Skyttä <scop@xemacs.org>
- add xemacs-21.4.13-utf8-fontsets.patch to eliminate warning about missing
  charsets in utf-8 locale with Xaw
- motif-specific xemacs-21.4.13-EmacsFrame-fontlock.patch no longer needed

* Fri Jun 27 2003 Jens Petersen <petersen@redhat.com> - 21.4.13-3
- add xemacs-21.4.13-dump-paths-lispdir.patch, so that the source lisp files
  get re-bytecompiled and dumped, not the installed ones
- use Athena/Xaw3d instead of motif for dialogs and widgets
- buildrequirements fixes
- use _localstatedir

* Sat May 31 2003 Jens Petersen <petersen@redhat.com> - 21.4.13-2
- add xemacs-21.4.13-EmacsFrame-fontlock.patch to stop font-lock being
  very slow (Ville Skyttä)

* Fri May 30 2003 Ville Skyttä <scop@xemacs.org>
- Use upstream icon in desktop entry, add missing semicolon to Categories.
- Have backup-by-copying-when-mismatch default to true in site-start.el.
- Mark init files as %%config.

* Thu May 29 2003 Jens Petersen <petersen@redhat.com> - 21.4.13-1
- update to 21.4.13
  - rcs2log-update.patch no longer needed
- buildrequire recent xemacs-sumo
- set system-uses-terminfo in default.el (#76102)
- use defvar in default.el not to override user's settings
- default gnus-default-article-saver to mbox format (#90604)
- add aspell as ispell program in site-start.el (#88262)
- add rpmbuild option "--with gtk" allowing building with gtk
- exclude s390x temporarily

* Mon May 12 2003 Jens Petersen <petersen@redhat.com> - 21.4.12-12
- sumo packages moved to separate xemacs-sumo package

* Sat May 10 2003 Jens Petersen <petersen@redhat.com> - 21.4.12-11
- build with system malloc on ppc64

* Tue Apr 22 2003 Jens Petersen <petersen@redhat.com> - 21.4.12-10
- obsoletes ruby-mode-xemacs (#84673)
- move obsoletes xemacs-sumo-el to -el subpackage
- fix links in jde html documentation (#89499)

* Tue Apr 15 2003 Jens Petersen <petersen@redhat.com> - 21.4.12-8
- comment out ja and ko menubar translations in X resource files for now,
  to avoid startup hanging in utf-8 locale (#88860)
- use default menubar font in ja and ko locale
- in a UTF-8 locale set default coding systems to utf-8 (partly #77130
  and #74227)
- set Info-directory-list in site-start.el again
- move psgml setup into site-start.el
- move previous contents of "dotxemacs-init.el" to new "default.el"

* Mon Mar 31 2003 Akira TAGOH <tagoh@redhat.com> 21.4.12-7
- Rebuild against the latest Canna.

* Thu Feb 20 2003 Jens Petersen <petersen@redhat.com> - 21.4.12-6
- default browse-url to use htmlview and update psgml-html browser
  defaults (#84262)

* Tue Feb 11 2003 Jens Petersen <petersen@redhat.com> - 21.4.12-5
- build with system-malloc on alpha and ia64
- skip redundant check-features target

* Thu Feb  6 2003 Jens Petersen <petersen@redhat.com> - 21.4.12-4
- fix "libexec dir" to be under lib64 on multilib archs
- set default ftp to be non-kerberos in site-start.el
- update sumos to 2003-02-05
- mspec patch and rpm-spec-mode update no longer needed
- buildrequire autoconf213
- add ".xemacs/init.el" to /etc/skel
- skip redundant check-features target on s390 and s390x

* Wed Jan 22 2003 Tim Powers <timp@redhat.com>
- rebuilt

* Tue Jan 21 2003 Jens Petersen <petersen@redhat.com> - 21.4.12-2
- fix `paths-emacs-root-p' (find-paths.el) to look in share not lib
- don't generate backup files when updating autoloads
- try startup notification in desktop file
- cleanup desktop file to use name XEmacs and add encoding key

* Fri Jan 17 2003 Jens Petersen <petersen@redhat.com> 21.4.12-1
- update to 21.4.12 bugfix release (21.4 series now declared stable branch)
- renumbered sumo package patches to be greater than 100
- install sumo packages by copying rather than moving
- patch sh-script.el to append m?spec entry to auto-mode-alist
- avoid ppc.ldscript and build on ppc
- remove games that we shouldn't ship
- update to latest rcs2log
- update to latest rpm-spec-mode.el
- use _smp_mflags for lib-src and src
- run batch-update-directory and batch-byte-recompile-directory on sumo lisp
  dirs
- improve datadir/xemacs-version/ ownership

* Sat Jan  4 2003 Jens Petersen <petersen@redhat.com> 21.4.11-1
- update to 21.4.11
- don't configure with union-type, since it causes runtime problems apparently
- only do postun info dir deletions when uninstalling

* Wed Jan  1 2003 Jens Petersen <petersen@redhat.com> 21.4.10-6
- move apel to separate package and require it
- renamed psgml-init.el-xemacs to xemacs-psgml-init.el
- use datadir in site-start.el
- really include the movemail mkstemp patch
- use mapc to load site-start.d files

* Tue Dec 31 2002 Ville Skyttä <scop@xemacs.org>
- New Sumos (2002-12-30).
- Use `construct-emacs-version-name' in `paths-emacs-root-p' (find-paths.el),
  fixing "Couldn't find obvious default for XEmacs hierarchy" warnings
  (as in XEmacs 21.5).
- Move site-start stuff to site-packages.
- Don't set Info-directory-list in site-start.el.
- Don't use --pkgdir, it's ignored.  Don't pass pkgdir to makeinstall.
- Fix source tarball URLs.
- Don't override the defcustom in psgml-init.el, set its default value instead.
- Add rpmbuild option: "--with debug" for building a debug-enabled XEmacs.

* Sun Dec 29 2002 Jens Petersen <petersen@redhat.com>
- updates package sumos to 2002-12-26 release

* Mon Dec 23 2002 Jens Petersen <petersen@redhat.com> 21.4.10-5
- patch find-paths.el to search in datadir
- setup lisp packages under datadir not libdir
- use buildroot macro instead of RPM_BUILD_ROOT
- drop local configure macro
- fix buildrequires and requires
- list configure options one-per-line
- improve psgml-init.el catalog setup
- remove and add lisp packages with package-admin
- rebyte-compile lisp packages
- keep etags as etags.xemacs (#78106)
- don't bother removing non-existent udp2tcp nor .cvsignore files
- simply filelist generation to a single find search pass
- put core .el files in -el package
- put package info files into -info package
- don't create backup files when patching in lisp packages tree
- don't explicitly gzip lisp package info files
- don't mark the applications files noreplace
- exclude ppc, since __init_array_start undefined

* Wed Dec 18 2002 Jens Petersen <petersen@redhat.com>
- patch egg-wnn to default to unix domain socket (#79826)
  [patch from ynakai@redhat.com]
- add ia64 patch from SuSE
- use mkstemp in movemail

* Tue Nov 19 2002 Jens Petersen <petersen@redhat.com>
- apply jlatex autodetect patch correctly and drop append to tex-site.el
- default to pTeX and pLaTeX for Japanese TeX and LaTeX

* Mon Nov 18 2002 Jens Petersen <petersen@redhat.com> 21.4.10-3
- backout uncommenting of deactivate-mark (#77696)
- update psgml dtd catalog path in psgml-init.el (#78022)
  [reported by ville.skytta@iki.fi]
- build with --use-union-type (#78024)
  [suggested by ville.skytta@iki.fi]

* Fri Nov 15 2002 Jens Petersen <petersen@redhat.com>
- fix autodetection of jlatex (#69129)

* Tue Nov 12 2002 Elliot Lee <sopwith@redhat.com> 21.4.10-2
- build on x86_64

* Mon Nov 11 2002 Jens Petersen <petersen@redhat.com> 21.4.10-1
- update to 21.4.10
- update sumos to 2002-09-19
- no longer backout mule-ucs package
- encode this file in utf-8
- xemacs-21.1.14-xfs.patch no longer needed
- use _libdir, _datadir, _bindir, _prefix
- exclude x86_64 (requires Canna)
- own /usr/lib/xemacs/{,mule-packages} and /usr/X11R6/lib/X11/<locale> (#73982)
  [reported by enrico.scholz@informatik.tu-chemnitz.de]
- fix default italic font size (#75275)
  [reported with fix by ville.skytta@iki.fi]
- update ja menubar translations in ja locale X resource file (#76068)
  [from ynakai@redhat.com]
- update ko locale X resource file (#76072) [from ynakai@redhat.com]
- add pkgdir rpm macro for packages dir
- uncomment deactivate-mark in simple.el (#77696)

* Mon Aug 26 2002 Trond Eivind Glomsrød <teg@redhat.com> 21.4.8-16
- some cleanups - and remove the info tarball, it's now part
  of the base tarball. Wow, the package gets smaller. (#72480)

* Mon Aug 19 2002 Trond Eivind Glomsrød <teg@redhat.com> 21.4.8-15
- Bug in specfile from -14 gave bug on startup (#71743)

* Thu Aug 15 2002 Trond Eivind Glomsrød <teg@redhat.com> 21.4.8-14
- Use utf-8 by default for input/output (#71584 )
- Make it not segfault when handling utf-8 (#71589)

* Wed Aug  7 2002 Trond Eivind Glomsrød <teg@redhat.com> 21.4.8-13
- Add openmotif-devel to buildrequires, as it will use it for widgets
  if it finds it

* Fri Aug  2 2002 Trond Eivind Glomsrød <teg@redhat.com> 21.4.8-12
- Don't package po-mode separately, it's now in sumo
- Compile with drag'n'drop support
- Use the bundled rpm-spec-mode, it has some adaptions for XEmacs

* Wed Jul 31 2002 Trond Eivind Glomsrød <teg@redhat.com> 21.4.8-11
- Don't use a separate ispell.el file anymore - the included one is newer
- Fix html-mode (#64826)

* Tue Jul 23 2002 Trond Eivind Glomsrød <teg@redhat.com> 21.4.8-10
- Update lisp tarballs
- desktop file fixes (#69542)
- Add bdb support (#65640)

* Mon Jul  8 2002 Trond Eivind Glomsrød <teg@redhat.com> 21.4.8-9
- Make it provide ruby-mode-xemacs (request from tagoh)

* Fri Jun 21 2002 Tim Powers <timp@redhat.com>
- automated rebuild

* Mon Jun 17 2002 Trond Eivind Glomsrød <teg@redhat.com> 21.4.8-7
- #66835

* Wed May 29 2002 Trond Eivind Glomsrød <teg@redhat.com> 21.4.8-6
- Make it build... Evil.
- Exclude IA64
- Upgrade sumo tarballs to 2002-05-22

* Fri May 24 2002 Jens Petersen <petersen@xemacs.org> 21.4.8-5
- Build using portable dumper, so that build with glibc-2.3 malloc is ok

* Mon May 13 2002 Trond Eivind Glomsrød <teg@redhat.com> 21.4.8-2
- Remove the s390 patches so it builds on s390 :)

* Fri May 10 2002 Trond Eivind Glomsrød <teg@redhat.com> 21.4.8-1
- 21.4.8

* Tue May  7 2002 Trond Eivind Glomsrød <teg@redhat.com> 21.4.6-9
- Rebuild... chmod -x pstogif to work around an rpm bug until
  it's fixed (#64320)

* Tue Apr 23 2002 Trond Eivind Glomsrød <teg@redhat.com> 21.4.6-8
- New sumo packages

* Thu Feb 21 2002 Trond Eivind Glomsrød <teg@redhat.com> 21.4.6-7
- Rebuild

* Tue Jan 29 2002 Jens Petersen <petersen@redhat.com> 21.4.6-6
- Remove skk package, since it conflicts with ddskk-xemacs (newer)

* Thu Jan 24 2002 Trond Eivind Glomsrød <teg@redhat.com> 21.4.6-5
- New sumos

* Wed Jan 09 2002 Tim Powers <timp@redhat.com>
- automated rebuild

* Wed Dec 19 2001 Jens Petersen <petersen@redhat.com> 21.4.6-3
- Fix fontlist pattern in Emacs.ad.Japanese.
- CHANGES-beta is now CHANGES-release.
- Obsolete xemacs-sumo xemacs-sumo-el

* Wed Dec 19 2001 Jens Petersen <petersen@redhat.com> 21.4.6-2
- Don't obsolete flim.

* Mon Dec 17 2001 Trond Eivind Glomsrød <teg@redhat.com> 21.4.6-1
- 21.4.6
- New sumo packages
- disable alpha

* Wed Nov 14 2001 Jens Petersen <petersen@redhat.com> 21.4.5-2
- Add -znocombreloc configure option to override new ld default.

* Tue Nov  6 2001 Trond Eivind Glomsrød <teg@redhat.com> 21.4.5-1
- 21.4.5. It builds on IA64 and fixes #55578
